config/routes.rb
Rails.application.routes.draw do
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
  resources :books
  get 'search_books' => 'books#search_books'

  resources :authors
  get 'search_authors' => 'authors#search_authors'

  resources :publishers
  get 'search_publishers' => 'publishers#search_publishers'

  root 'books#search_books'
end

app/models/author.rb
class Author < ApplicationRecord
  has_many :books, dependent: :destroy

  scope :find_all_by, -> (last_name, first_name) {
    @author_list = Author.all
    @author_list = @author_list.where("last_name LIKE ?", "%#{last_name}%" ) if last_name.present?
    @author_list = @author_list.where("first_name LIKE ?", "%#{first_name}%" ) if first_name.present?
  }

  validates :last_name, :presence => {:message => "Kérjük, válasszon ki egy vezetéknevet!" }
  validates :first_name, :presence => {:message => "Kérjük, válasszon ki egy keresztnevet!" }

  def full_author_name
    "#{first_name} #{last_name}"
  end
end

app/controllers/authors_controller.rb
class AuthorsController < ApplicationController

  include CheckValues
  include InitializeValues

  before_action { initialize_params(title = "Szerző keresése", @author_list = Author.all) unless @clicked }
  before_action :set_author, only: [:show, :edit, :update, :destroy]
  helper_method :calculate_page_idx_upper_bound, :check_boundaries, :convert_to_int

  def search_authors
    first_name = params[:first_name]
    last_name = params[:last_name]

    @per_page = convert_to_int(params[:per_page].to_i, 5)
    @per_page = 5 if @per_page.blank? || @per_page > 10 || @per_page < 3

    @current_page = convert_to_int(params[:page].to_i, 1)
    @current_page = check_boundaries(@current_page, calculate_page_idx_upper_bound(@author_list.count, @per_page))

    @clicked = is_clicked?(first_name, last_name)

    @author_list = Author.where("first_name LIKE ?", "%#{first_name}%") if first_name.present?
    @author_list = @author_list.where("last_name LIKE ?", "%#{last_name}%") if last_name.present?
    @author_list = @author_list.paginate(:page => @current_page, :per_page => @per_page)

    respond_to do |format|
      format.html { render :search_authors }
      format.xml { render :xml => @author_list }
      format.json { render :json => @author_list }
    end
  end

  # felugro ablak(modal) megnyitasa uj oldal helyett
  def show
    respond_to do |format|
      format.js
    end
  end

  def edit; end

  def new
    @author = Author.new
  end

  def create
    @author = Author.new(valid_params)
    @author.id = Author.all.pluck(:id).max + 1
    if @author.save
      redirect_to search_authors_path, notice: "A szerző <b>(#{h @author.last_name} #{h @author.first_name})</b> létrehozása sikeresen megtörtént!".html_safe
    else
      render :new
    end
  end

  def update
    if @author.update(valid_params)
      redirect_to search_authors_path, notice: "A szerző <b>(#{h @author.last_name} #{h @author.first_name})</b> módosítása sikeresen megtörtént!".html_safe
    else
      render :edit
    end
  end

  def destroy
    @author.destroy
    redirect_to search_authors_path, notice: "A szerző <b>(#{h @author.last_name} #{h @author.first_name})</b> törlése sikeresen megtörtént!".html_safe
  end

  private

  def valid_params
    params.require(:author).permit(:last_name, :first_name)
  end

  # edit, destroy, update, show előtt lefutó metódus, amely a kódduplikálás ellen van
  def set_author
    @author = Author.find_by_id(params[:id])
  end

end

app/helpers/author_helper.rb
module AuthorHelper

  include ApplicationHelper

  def show_author_message(last_name, first_name)
    msg = "<div class='alert alert-danger'>Nincs találat a következő kifejezésre: "
    msg +=  "<br>Vezetéknév: <b>#{h last_name}</b>" unless last_name.blank?
    msg +=  "<br>Keresztnév: <b>#{h first_name}</b>" unless first_name.blank?
    msg += "</div>"
    msg.html_safe
  end

end

app/views/authors/_author_modal.html.erb
<div id="author-modal" class="modal fade" role="dialog">
  <div class="modal-dialog modal-lg">
    <div class="modal-content">
      <div class="modal-header">
        <!--<button type="button" class="close" data-dismiss="modal">&times;</button>-->
        <h3 class="modal-title" style="text-align: left">Szerző megtekintése</h3>
      </div>

      <div class="modal-body">
        <p> Keresztnév: <span style="color: dodgerblue; "> <%=h @author.first_name %> </span> </p>
        <p> Vezetéknév: <span style="color: dodgerblue; "> <%=h @author.last_name %> </span> </p>
      </div>

      <div class="modal-footer">
        <button type="button" class="btn btn-danger" data-dismiss="modal">Bezárás</button>
      </div>
    </div>
  </div>
</div>

app/views/authors/_form.html.erb
<%= form_with(model: @author, local: true) do |f| %>
  <div class="form-group">
    <%= render "shared/errors", object: @author %>
    <table class="table" style="align-content: center" style="width: 1000px">
      <tr>
        <td style = "width: 100%">
          <%= f.label :first_name, "Szerző keresztneve" %><br>
          <%= f.text_field :first_name, autofocus: true, placeholder: "Szerző keresztneve", class: "form-control" %><br>
        </td>
      </tr>
      <tr>
        <td>
          <%= f.label :last_name, "Szerző vezetékneve" %><br>
          <%= f.text_field :last_name, placeholder: "Szerző vezetékneve", class: "form-control" %><br>
        </td>
      </tr>
    </table>
    <%= f.submit "Mentés", class: "btn btn-success" %>
    <%= link_to 'Mégsem', search_authors_path, class: 'btn btn-danger' %>
    <div style="text-align: right; margin-top: -35px"> <%= link_to 'Vissza a kereséshez', search_authors_path, class: 'btn btn-primary' %> </div>
  </div>
<% end %>

app/views/authors/edit.html.erb
<h1>Szerkesztés - <%= @author.first_name + " " + @author.last_name %></h1><br><br>
<%= render "form", author: @author %>

app/views/authors/new.html.erb
<h1>Szerző hozzáadása </h1><br><br>
<%= render "form", author: @author %>

app/views/authors/search_authors.html.erb
<div>
  <%= successful_action_msg(notice) %>
  <%= link_to 'Új könyv felvétele', new_book_path, class: 'btn btn-success' %>
  <%= link_to 'Új szerző felvétele', new_author_path, class: 'btn btn-success' %>
  <%= link_to 'Új kiadó felvétele', new_publisher_path, class: 'btn btn-success' %><br><br>

  <%= form_tag search_authors_path, :method => "get" do %>
    <div class="form-group">
      <label><b>Szerző keresése</b> - Szűrési feltételek </label>
      <table class="table" style="align-content: center">
        <tr>
          <td style="width: 50%"><%= text_field_tag(:first_name, params[:first_name], placeholder: "Keresztnév", class: "form-control") %></td>
          <td style="width: 50%"><%= text_field_tag(:last_name, params[:last_name], placeholder: "Vezetéknév", class: "form-control") %></td>
        </tr>

        <tr>
          <td colspan="2" style="width: 10%" >
            Találatok oldalanként
            <input id="per_page" name="per_page" min="3" max="10" type="number" class="form-control" value="<%= @per_page %>" style="width: 60px"/>
          </td>
        </tr>

        <tr>
          <td>
            <%= submit_tag "Keresés", class: "btn btn-primary" %>
          </td>
        </tr>

      </table>

    </div>
  <% end %>

  <% if @author_list.count == 0 %>
    <table class="table">
      <tr>
        <td scope="row">
          <%= show_author_message(params[:first_name], params[:last_name]) %>
        </td>
      </tr>
    </table>
  <% end %>

  <% unless @author_list.nil? || @author_list.empty? %>
    <table>
      <tr>
        <th scope="row">
          Találatok száma: <span style = "color: green"> <%= @author_list.count %> </span>
        </th>
      </tr>
    </table>
    <br>
    <table class="table">
      <thead>
      <tr>
        <th scope="col">#</th>
        <th scope="col">Keresztnév</th>
        <th scope="col">Vezetéknév</th>
        <th scope="col" colspan="3" width="25%" style="text-align:center">Műveletek</th>
      </tr>
      </thead>
      <tbody>

      <% list_size = @author_list.count %>
      <% @author_list.each_with_index do |author, idx| %>
        <%= set_row_background(idx) %>
        <th scope="row"> <%= current_index(idx, list_size, @current_page, @per_page) %> </th>
        <td> <%= h author.first_name if author %> </td>
        <td> <%= h author.last_name if author %> </td>
        <td> <%= link_to 'Megtekintés',  author_path(author.id), remote: true, class: 'btn btn-info' %> </td>
        <td> <%= link_to 'Szerkesztés', edit_author_path(author.id), class: 'btn btn-warning'%> </td>
        <td> <%= link_to 'Törlés', author_path(author.id),
                         class: 'btn btn-danger',
                         method: :delete,
                         data: { confirm: "Biztosan törli a következőt?\n
    Keresztnév: #{h author.first_name}
    Vezetéknév: #{h author.last_name}"} %></td>
        </tr>
      <% end %>
      </tbody>
    </table>
  <% end %>
</div>

<div class="row">
  <div class="col offset-4">
    <!-- ez a kódrészlet felel az egyes aloldalak linkként való megjelenítéséért -->
    <%= will_paginate @author_list, :previous_label => 'Előző', :next_label => 'Következő', renderer: WillPaginate::ActionView::Bootstrap4LinkRenderer %>
  </div>
</div>

<!-- MODAL MEGNYITASA JS-sel - megtekintés -->
<div id='author-content'></div>

<!-- https://dev.to/morinoko/adding-custom-javascript-in-rails-6-1ke6 -->
<%= javascript_pack_tag 'message_alerts' %>

app/views/authors/show.js.erb
$('#author-content').html("<%= j render 'author_modal', author: @author %>");
$('#author-modal').modal('show');